import { system, world } from "@minecraft/server";
import WardenArmor from "./warden";
import { ArmorSlot, hasInInventory } from "../../libraries/utils";
system.runInterval(() => {
    for (const player of world.getPlayers()) {
        const equipment = player.equippable;
        const inventory = player.inventory.container;
        for (const slot of Object.keys(WardenArmor)) {
            if (slot === "id")
                continue;
            const item = equipment.getEquipment(slot);
            const armor = WardenArmor[slot];
            if (!item || !armor)
                continue;
            if (item.typeId != `${WardenArmor.id}_${ArmorSlot[slot]}`)
                continue;
            const { command, effect } = armor;
            const findedInventory = hasInInventory(player, `${WardenArmor.id}_${ArmorSlot[slot]}`, true);
            findedInventory.map(slotObject => {
                slotObject.item.setLore([`\n${armor.lore}`]);
                inventory.setItem(slotObject.slot, slotObject.item);
            });
            armor.lore ? item.setLore([`\n${armor.lore}`]) : null;
            effect ? player.addEffect(effect.id, effect.duration, { amplifier: effect.amplifier, showParticles: false }) : null;
            command ? player.runCommandAsync(command) : null;
            armor.func ? armor.func(player) : null;
            equipment.setEquipment(slot, item);
        }
    }
}, 0);
